# coding: utf-8

"""
    Pulp 3 API

    Fetch, Upload, Organize, and Distribute Software Packages  # noqa: E501

    The version of the OpenAPI document: v3
    Contact: pulp-list@redhat.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from pulpcore.client.pulp_python.configuration import Configuration


class PythonBanderRemote(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'config': 'file',
        'name': 'str',
        'policy': 'PolicyEnum'
    }

    attribute_map = {
        'config': 'config',
        'name': 'name',
        'policy': 'policy'
    }

    def __init__(self, config=None, name=None, policy=None, local_vars_configuration=None):  # noqa: E501
        """PythonBanderRemote - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._config = None
        self._name = None
        self._policy = None
        self.discriminator = None

        self.config = config
        self.name = name
        if policy is not None:
            self.policy = policy

    @property
    def config(self):
        """Gets the config of this PythonBanderRemote.  # noqa: E501

        A Bandersnatch config that may be used to construct a Python Remote.  # noqa: E501

        :return: The config of this PythonBanderRemote.  # noqa: E501
        :rtype: file
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this PythonBanderRemote.

        A Bandersnatch config that may be used to construct a Python Remote.  # noqa: E501

        :param config: The config of this PythonBanderRemote.  # noqa: E501
        :type: file
        """
        if self.local_vars_configuration.client_side_validation and config is None:  # noqa: E501
            raise ValueError("Invalid value for `config`, must not be `None`")  # noqa: E501

        self._config = config

    @property
    def name(self):
        """Gets the name of this PythonBanderRemote.  # noqa: E501

        A unique name for this remote  # noqa: E501

        :return: The name of this PythonBanderRemote.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PythonBanderRemote.

        A unique name for this remote  # noqa: E501

        :param name: The name of this PythonBanderRemote.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def policy(self):
        """Gets the policy of this PythonBanderRemote.  # noqa: E501

        The policy to use when downloading content. The possible values include: 'immediate', 'on_demand', and 'streamed'. 'on_demand' is the default.  # noqa: E501

        :return: The policy of this PythonBanderRemote.  # noqa: E501
        :rtype: PolicyEnum
        """
        return self._policy

    @policy.setter
    def policy(self, policy):
        """Sets the policy of this PythonBanderRemote.

        The policy to use when downloading content. The possible values include: 'immediate', 'on_demand', and 'streamed'. 'on_demand' is the default.  # noqa: E501

        :param policy: The policy of this PythonBanderRemote.  # noqa: E501
        :type: PolicyEnum
        """

        self._policy = policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PythonBanderRemote):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PythonBanderRemote):
            return True

        return self.to_dict() != other.to_dict()
